
package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.EmpresaSicfeConfigDAO;
import com.rjconsultores.ventaboletos.entidad.EmpresaSicfeConfig;


@Repository("empresaSicfeConfigDAO")
public class EmpresaSicfeConfigHibernateDAO extends GenericHibernateDAO<EmpresaSicfeConfig, Integer>
		implements EmpresaSicfeConfigDAO {

	@Autowired
	public EmpresaSicfeConfigHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<EmpresaSicfeConfig> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		return c.list();
	}

	public EmpresaSicfeConfig buscarChave(String chave, Integer empresaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));

		c.add(Restrictions.eq("chave", chave));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));

		return (EmpresaSicfeConfig) c.uniqueResult();
	}
	
	public List<EmpresaSicfeConfig> buscarByEmpresa(Integer empresaId) {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("empresa.empresaId", empresaId));

		return c.list();
	}
}
